<template>
  <div id="products">
    <v-container fluid>
      <v-row class="d-flex justify-center mt-5">
        <v-card class="mt-8 elevation-8 mx-auto mb-7" style="width: 90%">
          <v-card-title class="d-block text-center pt-6 pb-5 text-h4">
            Prodotti
          </v-card-title>
          <v-card-text>
            <v-data-table
                hide-default-footer
                :items="products"
                :headers="headers"
                item-key="item.id"
            >
              <template v-slot:top>
                <v-toolbar
                    flat
                >
                  <v-btn
                      color="primary"
                      dark
                      rounded
                      class="mb-2"
                      @click="dialog = true"
                      v-if="$store.getters.isAdmin"
                  >
                    <v-icon small>far fa-plus-square</v-icon>
                  </v-btn>
                </v-toolbar>
              </template>
              <template v-slot:item.rating="{ item }">
                <div>
                  <v-icon
                    small
                    color="primary"
                    v-for="index in item.rating"
                    :key="index"
                  >
                    fas fa-star
                  </v-icon>
                </div>
              </template>
              <template v-slot:item.actions="{ item }">
                <div v-if="$store.getters.isAdmin">
                  <v-icon
                      small
                      color="primary"
                      class="mx-2"
                      @click="editProductPopup(item)"
                  >
                    fas fa-edit
                  </v-icon>
                  <v-icon
                      small
                      color="primary"
                      class="mx-2"
                      @click="deleteProduct(item)"
                  >
                    fas fa-trash
                  </v-icon>
                </div>
                <div v-else>
                  <v-icon
                      small
                      color="primary"
                      class="mx-2"
                      @click="addProductToCart(item)"
                  >
                    fas fa-shopping-cart
                  </v-icon>
                </div>
              </template>
            </v-data-table>
          </v-card-text>
        </v-card>
      </v-row>
    </v-container>

    <v-dialog
        v-model="dialog"
        width="50%"
        @click:outside="closeDialog"
        @close="closeDialog"
    >
      <v-card class="pt-10">
        <v-card-text>
          <v-text-field
              id="name"
              label="Nome"
              name="name"
              v-model="product.name"
              outlined
              prepend-icon="far fa-store"
              type="text"
          ></v-text-field>
          <v-text-field
              id="rating"
              label="Valutazione"
              name="rating"
              v-model="product.rating"
              outlined
              prepend-icon="fas fa-star"
              type="number"
              :rules="productRateRule"
          ></v-text-field>
          <v-select
              :items="categories"
              v-model="category"
              prepend-icon="fas fa-folder"
              item-text="name"
              item-value="id"
              return-object
              label="Categoria"
              outlined
          ></v-select>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" @click="productToEditId !== null ? editProduct() : createProduct()">
            Salva
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>

</template>

<script>
export default {
  name: "Products",
  data() {
    return {
      headers: [
        {value: 'id', text: 'Id'},
        {value: 'name', text: 'Nome'},
        {value: 'rating', text: 'Valutazione'},
        {value: 'category.name', text: 'Categoria'},
        {text: 'Actions', value: 'actions', sortable: false}
      ],
      products: [],
      dialog: false,
      product: {
        name: null,
        rating: null,
        categoryId: null
      },
      category: {
        id: null,
        name: null
      },
      productToEditId: null,
      categories: [],
      productRateRule: [
        v => !!v || "Questo campo è obbligatorio!",
        v => ( v && v >= 0 ) || "La valutazione deve essere almeno 0",
        v => ( v && v <= 5 ) || "La valutazione deve essere al massimo 5",
      ],
    }
  },
  watch: {
    category(newVal, old) {
      console.log('Category selected: ' + JSON.stringify(old) + ' --> ' + JSON.stringify(newVal))
      console.log(this.category)
    }
  },
  mounted() {
    this.getProducts()
    this.getCategories()
  },
  methods: {
    async getProducts() {
      let response = await this.$http.get('/products');
      this.products = response.data;
    },

    async getCategories() {
      let response = await this.$http.get('/categories');
      this.categories = response.data;
    },

    async deleteProduct(item) {
      if (window.confirm("Sei sicuro di voler eliminare " + item.name + "?")) {
        await this.$http.delete('/products/' + item.id)
        await this.getProducts()
      } else
        window.alert('Menomale, poverino!')

    },
    async editProduct() {
      if(!this.validateProduct(this.product)) return;
      this.product.categoryId = this.category.id;
      try {
        await this.$http.put('/products/' + this.productToEditId, this.product)
      } catch (error) {
        window.alert('Errore nella creazione!')
      } finally {
        await this.closeDialog()
      }
    },

    async createProduct() {
      if(!this.validateProduct(this.product)) return;
      this.product.categoryId = this.category.id;
      try {
        await this.$http.post('/products', this.product)
      } catch (error) {
        window.alert('Errore nella creazione del prodotto. \n Aprire la console per i dettagli')
        console.log(error)
      } finally {
        await this.closeDialog()
      }
    },

    async addProductToCart(item) {
      try {
        await this.$http.post('/cart/' + this.$store.getters.id + '/' + item.id)
        window.alert('prodotto: ' + item.name + ' aggiunto al tuo carrello!')
      } catch (e) {
        window.alert("errore: " + e)
      }

    },

    editProductPopup(item) {
      this.product.name = item.name;
      this.product.rating = item.rating;
      this.category = item.category;
      this.productToEditId = item.id;
      this.dialog = true;
    },
    async closeDialog() {
      this.resetProduct();
      this.dialog = false;
      await this.getProducts();
    },
    resetProduct() {
      this.product.name = null;
      this.product.rating = null;
      this.product.categoryId = null;
      this.productToEditId = null
    },

    validateProduct(product) {
      if(product.rating === null || product.rating < 0 || product.rating > 5) {
        window.alert("La valutazione del prodotto non rispetta le regole!")
        return false;
      }
      else if (product.name === "") {
        window.alert("Il nome del prodotto non puo' essere vuoto!")
        return false;
      }
      return true;
    }
  }
}
</script>


<style scoped>

</style>
